<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow  xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   xmlns:componente="br.com.desenv.framework.componente.*"
			   close="titlewindowCloseHandler(event)"  
			   creationComplete="creationCompleteHandler(event)" 
			   title="Cadastro de Log Duplicata"
			  maxWidth="1200" maxHeight="700"  
			   xmlns:visual="br.com.desenv.framework.component.visual.*"   xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
			   
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	
	<fx:Metadata>
		[Event(name="LogDuplicataIncluidoEvent")]
		[Event(name="LogDuplicataAtualizadoEvent")]
		[Event(name="LogDuplicataExcluidoEvent")]
		[Event(name="LogDuplicataSelecionadoEvent")]
		
	</fx:Metadata>

	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.validators.Validator;
			import spark.events.TitleWindowBoundsEvent;
			
			import br.com.desenv.nepalign.vo.LogDuplicata;
			
			// Alguem passa a objeto para ca
			public var logDuplicata : LogDuplicata = new LogDuplicata();
			

			
			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}
			
			private function limparListaCampo(): void
			{
				ignTextInputMotivo.text = "";
				ignTextInputDateData.text = "";
				ignTextInputValorOriginal.text = "";
				ignTextInputValorAlterado.text = "";
				ignTextInputNomeUsuario.text = "";
			}
			
			// Chama ao completar o carregamento da pagina
			private function creationCompleteHandler( event: FlexEvent ): void 
			{
				carregarListaValidacao();
				
				
				// Se e um novo cadastro
				if (isNaN(this.logDuplicata.id))
				{
					limparListaCampo();
				}
				// Se alguem passou o objeto
				else
				{
					ignTextInputMotivo.text = this.logDuplicata.motivo;

					ignTextInputDateData.text = DateField.dateToString(this.logDuplicata.data, "DD/MM/YYYY"); 

					ignTextInputValorOriginal.text = this.logDuplicata.valorOriginal;

					ignTextInputValorAlterado.text = this.logDuplicata.valorAlterado;

					ignTextInputNomeUsuario.text = this.logDuplicata.nomeUsuario;

				}
			}
			
			
			
			
			// Chama quando fecha a janela no X
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- SALVAR E ATUALIZAR  --------------------------------	
			private function buttonSalvar_clickHandler( event: MouseEvent ): void 
			{
				if (validar(event))
				{
					// Se e alteracao
					if (isNaN(logDuplicata.id) == false) 
					{
						logDuplicata.motivo = ignTextInputMotivo.text;
						logDuplicata.data = ignTextInputDateData.text == ""?null:DateField.stringToDate(ignTextInputDateData.text, "DD/MM/YYYY");
						logDuplicata.valorOriginal = ignTextInputValorOriginal.text;
						logDuplicata.valorAlterado = ignTextInputValorAlterado.text;
						logDuplicata.nomeUsuario = ignTextInputNomeUsuario.text;
						var remoteObjectAtualizar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("logDuplicataService", atualizarResultHandler);	
						remoteObjectAtualizar.getOperation("atualizar").send(logDuplicata); 
					// Se e inclusao
					} 
					else 
					{
						logDuplicata.motivo = ignTextInputMotivo.text;

						logDuplicata.data = ignTextInputDateData.text == ""?null:DateField.stringToDate(ignTextInputDateData.text, "DD/MM/YYYY");

						logDuplicata.valorOriginal = ignTextInputValorOriginal.text;

						logDuplicata.valorAlterado = ignTextInputValorAlterado.text;

						logDuplicata.nomeUsuario = ignTextInputNomeUsuario.text;

						var remoteObjectSalvar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("logDuplicataService", salvarResultHandler);	
						remoteObjectSalvar.getOperation("salvar").send(logDuplicata); 
					}
				}	
			}

			
			// Depois que salva fecha a janela
			private function salvarResultHandler( event: ResultEvent ): void 
			{
				this.logDuplicata = event.result as LogDuplicata;
				this.dispatchEvent(new ResultEvent("LogDuplicataIncluidoEvent",false, true, this.logDuplicata, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			// Depois que atualiza fecha a janela
			private function atualizarResultHandler( event: ResultEvent ): void 
			{
				this.logDuplicata = event.result as LogDuplicata;
				this.dispatchEvent(new Event("LogDuplicataAtualizadoEvent"));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- LIMPAR  --------------------------------	
			protected function buttonLimpar_clickHandler(event:MouseEvent):void
			{
				limparListaCampo();
			}
						
// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				

			
// ---------------------------------- PESQUISAR AUTOR ABRINDO A LISTA  --------------------------------				
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<!-- <mx:Validator id="validatorObrigatorioSituacaoLogDuplicata" property="selectedItem" required="true" source="{comboBoxSituacaoLogDuplicata}" trigger="{comboBoxSituacaoLogDuplicata}" triggerEvent="valueCommit"/> -->
		

		<s:ArrayCollection id="listaOpcaoSimNao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Nao"/>
		</s:ArrayCollection>
					
	</fx:Declarations>
	

	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="720" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Motivo:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoMotivo" styleName="labelValidacao" text="{ignTextInputMotivo.errorString}"/>
					<visual:IgnTextInput id="ignTextInputMotivo" maxChars="255" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Data:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoData" styleName="labelValidacao" text="{ignTextInputDateData.errorString}"/>
					<visual:IgnTextInputDate id="ignTextInputDateData" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Valor Original:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoValorOriginal" styleName="labelValidacao" text="{ignTextInputValorOriginal.errorString}"/>
					<visual:IgnTextInput id="ignTextInputValorOriginal" maxChars="255" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Valor Alterado:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoValorAlterado" styleName="labelValidacao" text="{ignTextInputValorAlterado.errorString}"/>
					<visual:IgnTextInput id="ignTextInputValorAlterado" maxChars="255" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Nome Usuario:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoNomeUsuario" styleName="labelValidacao" text="{ignTextInputNomeUsuario.errorString}"/>
					<visual:IgnTextInput id="ignTextInputNomeUsuario" maxChars="255" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>



 			<mx:GridItem colSpan="2">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Button id="buttonSalvar" label="Salvar" click="buttonSalvar_clickHandler(event)"/>
				<s:Button id="buttonLimpar" label="Limpar" click="buttonLimpar_clickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>
</s:TitleWindow>